'
'CMM2 M*berto - a distant cousin to Q*bert ;-)
'
'developed by yock1960 - 2021
'
'm-berto version 14 - todo -  support for character SAM, more levels, 2 players, splash screen, improve sprite animation
'
clear

#include "playfield.inc"
#include "levels.inc"
#include "wrongway2.inc"
#include "green_egg.inc"
#include "ugg.inc"
#include "hiscore.inc"

const TRUE = 1
const FALSE = 0
const DEAD = FALSE
const LIVE = TRUE
const EGG = -1
const EMBRYO = 2
const QBERT = 1       '1-4
const REDEGG = 5      '5-12
const GREENEGG = 13   '13,14
const COILYEGG = 15   '15,16
const COILY = 17      '17-20
const WRONGWAY = 21   '21-24
const UGG = 25        '25-28
const SAM = 28        '29-32
const DOH = 33
const WRONGWY = 34
const UGGU = 38
const DISC = 47       '47-54
const UP = 0
const DOWN = 2
const UPRIGHT = 0 
const UPLEFT = 1
const DNRIGHT = 0
const DNLEFT = 1
const PLYRTXT = 55
'sound constants
const JUMP = 1
const LIFT= 2
const TUNE = 3
const TUNE2 = 4
const FALL = 5
const EGGDROP = 6
const COILYFALL = 7
const UGGSPEECH = 8
const WRONGWAYSPEECH = 9
const QBERTDIES = 10
const PRIZE = 11
const COILYJUMP = 12
const FREEZE = 13
const COINDROP = 14 
'cube definition
dim c%(2) = (4,4,4)
dim x%(12) = (224,240,256,240, 224,224,240,240, 240,240,256,256,240)
dim y%(12) = (100,92,100,108, 100,120,128,108, 108,128,120,100,108)
dim nxstartcolor%(2)
dim nxfinishcolor%(2) 
dim startcolor%(2)
dim finishcolor%(2) 
dim color1%(2)
dim nextx%(12),nexty%(12)
dim playfield%(8,14)
dim qbert_location!(1)
dim coily_location!(1)
dim coily_death!(1)
dim col_location!(1)
dim redegg_location!(3,1)
dim gregg_location!(1)
dim ugg_location!(1)
dim wrgway_location!(1)
dim elev_location!(1)
dim qhx = 122
dim nz
dim qhy = 20+28
dim side%
dim kb$
dim reggs% = 3      'how many red eggs allowed
dim disc_pairs(14,1)
dim sdisc!(7,2)
dim c_must_die% = FALSE
'to change color of tops of cubes
dim c1% = (4)
dim x1%(3) = (224,240,256,240)
dim y1%(3) = (100,92,100,108)
dim fc1% = (rgb(183,175,64))
dim flg% = FALSE
'used in make playfield
dim nextx1%(3),nexty1%(3)
dim k% = 6
dim s% = DISC
dim p% = 0
dim q% = 0
dim o%,m%
dim vec!
dim r%
dim t%
dim base_spr%,cur_spr%,b_spr%,c_cur_spr%,re_cur_spr%(3)
dim u_cur_spr%,w_cur_spr%,gr_cur_spr%
dim level% = 1
dim round% = 1
dim field%(14,8)
dim HaveClassic = FALSE
dim HaveNunchuk = FALSE
dim qstate = DEAD
dim cstate = DEAD
dim wstate = DEAD
dim gstate = DEAD
dim ustate = DEAD
dim restate(3)
dim score% = 25
dim cube_cnt% = 0
dim newlevel = TRUE
dim level_colr%
dim round_colr%
'mainloop timer
dim mltimer%
'timer for timing coily drop in
dim ctimer%,ct%
dim fg%,e%
dim c_cnt%,rcnt1%,rcnt2%
dim pawsed = FALSE
dim discnt%
dim pflag% = FALSE        'button pressed
dim cflag% = FALSE        'collision occured
dim c_activated% = FALSE
dim qlives% = 3
dim gover% = FALSE
dim testimer=0
dim testimer2
dim cly_int%
dim rdg_int%
dim ww_int% = 0
dim badguy$
dim dist%
dim exlife_flag=TRUE
dim exlife2_flag=TRUE
dim dabug = FALSE
dim grtimer% = 0 
dim w_u_flg% = UGG
dim ng_flg% = TRUE
dim grcount% = 4      'start at 4, double for each egg used per round
dim player$(1)
dim hiscores$(9,1)
dim highscore%(9)
dim cur_plyer% = 0

ls_pairs:
data -.5,7.2,.5,6.2,1.5,5.2,2.5,4.2,3.5,3.2,4.5,2.2,5.5,1.2
rs_pairs:
data 14.5,7.2,13.5,6.2,12.5,5.2,11.5,4.2,10.5,3.2,9.5,2.2,8.5,1.2


player$(0) = ""
player$(1) = ""

get_player(cur_plyer%)
get_hiscores


restore playfield
for o% = 0 to 8
  for m% = 0 to 14
    read field%(m%,o%)
  next
next
math scale field%(),1,playfield%()

restore ls_pairs
for o% = 1 to 7
  read disc_pairs(o%,0)
  read disc_pairs(o%,1)
next
restore rs_pairs
for o% = 8 to 14
  read disc_pairs(o%,0)
  read disc_pairs(o%,1)
next  
calc_discs(1,1)

restate(0) = DEAD
restate(1) = DEAD
restate(2) = DEAD
restate(3) = DEAD

mode 4,12,RGB(BLACK),screen_refresh

'page display 3
cls
page write 3
cls
load png "./assets/qbert_creatures.png",0,0,15
load png "./assets/qbert_cubes_level1.png",129,0,15
load png "./assets/qbert_player_scroll.png",240,0,15
load png "./assets/qbert - misc_text.png",347,0,15
load png "./assets/qbert_spinning_discs.png",0,160,5
load png "./assets/qbert_alphanumeric.png",0,225,15
load png "./assets/qbert_doh.png",0,256,15

play modfile "./assets/qbert_sounds_2.mod",22050

'qbert 1-4
sprite read QBERT+UP,     0,0,16,16,3
sprite read QBERT+UP+1,  16,0,16,16,3
sprite read QBERT+DOWN,  64,0,16,16,3
sprite read QBERT+DOWN+1,80,0,16,16,3

'make 'lives' character
blit 0,0,mm.hres-16,mm.vres-16,16,16,3
image resize mm.hres-16,mm.vres-16,16,16,mm.hres-32,mm.vres-16,12,12,3


'red egg 5-12
sprite read REDEGG,  16,16,16,16,3    'egg #1
sprite read REDEGG+1, 0,16,16,16,3
sprite read REDEGG+2,16,16,16,16,3    'egg #2
sprite read REDEGG+3, 0,16,16,16,3
sprite read REDEGG+4,16,16,16,16,3    'egg #3
sprite read REDEGG+5, 0,16,16,16,3
sprite read REDEGG+6,16,16,16,16,3    'egg #4
sprite read REDEGG+7, 0,16,16,16,3

'green ball 13-14
sprite read GREENEGG,  48,16,16,16,3
sprite read GREENEGG+1,32,16,16,16,3

'coily egg 15-16
sprite read COILYEGG,  80,16,16,16,3
sprite read COILYEGG+1,64,16,16,16,3

'coily 17-20
sprite read COILY+UP,     0,32,16,32,3
sprite read COILY+UP+1,  16,32,16,32,3
sprite read COILY+DOWN,  64,32,16,32,3
sprite read COILY+DOWN+1,80,32,16,32,3

'wrongway 21-24
sprite read WRONGWAY+0, 0,112,16,16,3
sprite read WRONGWAY+1,16,112,16,16,3
sprite read WRONGWAY+2,32,112,16,16,3
sprite read WRONGWAY+3,48,112,16,16,3

'ugg 25-28
sprite read UGG+0, 0,96,16,16,3
sprite read UGG+1,16,96,16,16,3
sprite read UGG+2,32,96,16,16,3
sprite read UGG+3,48,96,16,16,3

'sam 29-32
sprite read SAM+0,  0,160,16,16,3
sprite read SAM+1, 16,160,16,16,3
sprite read SAM+2, 32,160,16,16,3
sprite read SAM+3, 48,160,16,16,3

'Qbert swears 33
sprite read DOH,0,256,50,27,3

'wrongway going up 34-37
sprite read WRONGWY+0,64,112,16,16,3
sprite read WRONGWY+1,80,112,16,16,3
sprite read WRONGWY+2,96,112,16,16,3
sprite read WRONGWY+3,112,112,16,16,3

'wrongway going up 38-41
sprite read UGGU+0,64,96,16,16,3
sprite read UGGU+1,80,96,16,16,3
sprite read UGGU+2,96,96,16,16,3
sprite read UGGU+3,112,96,16,16,3


'disc 47-54
sprite read DISC,129,193,16,16,3
sprite read DISC+1,145,193,16,16,3
sprite read DISC+2,161,193,16,16,3
sprite read DISC+3,177,193,16,16,3
'disc with qbert on board
sprite read DISC+4,0,181,16,21,3
sprite read DISC+5,16,181,16,21,3
sprite read DISC+6,32,181,16,21,3
sprite read DISC+7,48,181,16,21,3


'player number
blit read  62,347,0,8,12,3
'level text
blit read  61,347,12,30,8,3
'round text
blit read  60,347,20,30,8,3
'chage to text
blit read  59,347,28,50,8,3
'right arrow
blit read  58,347+24,0,8,8,3
'left arrow
blit read  57,347+32,0,8,8,3


'page display 0

page write 0

display_hiscores(0,0)


' used for cube flashing
blit read 64,120,89,9*28,9*28
blit read 63,120,89,9*28,9*28,5

banner

play modsample COINDROP,1,64,22050   'tune-3.wav  all egg sounds on channel 1, shared with tunes

pause 2500

'l% = l% - 1     'what is this?
flg% = TRUE

qbert_location(0) = 7
qbert_location(1) = 1

selectinputdevice(1) 

new_game
help_me

do while kb$ <> "q" 

kb$ = inkey$ 
'mltimer% = timer


   if pflag% <> TRUE then
    if kb$ = chr$(129) then  'down right
         pflag% = TRUE
         hop(1,1)
         pause 50
             
    else if kb$ = chr$(128) then  'up left
        pflag% = TRUE
        hop(-1,-1)
         pause 50
        
    else if kb$ = chr$(131) then  'up right
        pflag% = TRUE
        hop(1,-1)  
         pause 50
        
    else if kb$ = chr$(130) then 'down left
        pflag% = TRUE
        hop(-1,1)
         pause 50
        
    end if


  end if

  
if kb$ = "p" and not pawsed then
  pawsed = TRUE
  settick 0,coilly,1
  settick 0,redeg,4
  settick 0,wrgway,3
  cly_int% = 950
  rdg_int% = 950
  ww_int% = 950
else if kb$ = "p" and pawsed then
  pawsed = FALSE
  settick cly_int%,coilly,1
  settick rdg_int%,redeg,4
  if round% >= 3 then
    settick ww_int%,wrgway,3
  end if
  
end if


if qstate = DEAD then
  qstate = LIVE
  qbert_location(0) = 7
  qbert_location(1) = 1
  cly_int% = 2000

  if CSTATE <> DEAD then
    sprite hide safe c_cur_spr%    
    cstate = DEAD
    ct% = 0
    settick cly_int%,coilly,1
  end if

  drop_in(TRUE)

end if


  text 380,80,str$(level%)+" ",L,7,,level_colr%
  text 380,90,str$(round%)+" ",L,7,,round_colr%


  if score% > 0 then
    text 20,27,str$(score%),L,,,RGB(RED)
  end if


  if dabug then
    diagnostic
  end if

loop

put_scores

end



sub banner
  text 150,mm.vres-50,"M~Berto!",L,5,,RGB(RED)
end sub

sub help_me
  text 5,mm.vres-35,"'P' key to pause",L,7,,RGB(GREEN)
  text 5,mm.vres-20,"'Q' key to quit game",L,7,,RGB(GREEN)
end sub

sub manage_lives(lives%)
  
  select case lives%


    case 4,5,6
      blit mm.hres-32,mm.vres-16,20,130,12,12,3
      blit mm.hres-32,mm.vres-16,20,150,12,12,3
      blit mm.hres-32,mm.vres-16,20,170,12,12,3
      blit mm.hres-32,mm.vres-16,20,190,12,12,3

    case 3
      blit 20,210,20,130,12,12,1
      blit mm.hres-32,mm.vres-16,20,150,12,12,3
      blit mm.hres-32,mm.vres-16,20,170,12,12,3
      blit mm.hres-32,mm.vres-16,20,190,12,12,3

    case 2
      blit 20,210,20,150,12,12,1
      blit mm.hres-32,mm.vres-16,20,170,12,12,3
      blit mm.hres-32,mm.vres-16,20,190,12,12,3

    case 1
      blit 20,210,20,170,12,12,1
      blit mm.hres-32,mm.vres-16,20,190,12,12,3

    case 0
      blit 20,210,20,190,12,12,1

    case -1
      game_over
      new_game

    end select

      
end sub   'manage lives


sub game_over
  local k$,n%,flg%=0

   do while k$ <> ""
     k$ = inkey$
   loop
  

   gover% = TRUE

   for n% = 9 to 0 step -1
     if score% < highscore%(n%) then
      flg% = 1
      exit for
     end if
   next
    
   if score% < highscore%(9) then
    n%=1
    flg% = 0
   end if 
     
   if n% < 0 then
      inc n%
      if score% > highscore%(0) then
        flg% = 0
        new_hiscore(n%)
        play modsample PRIZE,1,64,22050   'prize.wav  
        display_hiscores(n%,1)
        put_scores
      end if
   end if
   
   if flg% then
      if n% < 9 then
        inc n%
      end if
      new_hiscore(n%)
      play modsample PRIZE,1,64,22050   'prize.wav  
      display_hiscores(n%,1)
      put_scores
    end if
 
   
   settick 0,redeg,4
   settick 0,coilly,1
   settick 0,wrgway,3

   wstate = DEAD
   ustate = DEAD
   gstate = DEAD

   for n% = QBERT to UGG+3
     if sprite(x,n%) <> 10000 then
      sprite hide safe n%
     end if
   next
   
   pflag% = TRUE
   
   do while k$ = ""
    k$ = inkey$ 
    screen_refresh
   loop
   
   pflag% = FALSE
   
   gover% = FALSE

end sub   ' game over
  

sub collision
  local  c%

  
  if cflag% = GREENEGG then
    exit sub
  end if
     
     if coily_location!(0) = qbert_location!(0) then
       if coily_location!(1) = qbert_location!(1) then      
          set_col_parms(COILY,100,0,0)
        exit sub
       end if
     end if
     
      for c% = 0 to reggs%
        if redegg_location!(c%,0) = qbert_location!(0) then
          if redegg_location!(c%,1) = qbert_location!(1) then      
             set_col_parms(REDEGG,0,100,0)
            exit sub
          end if
        end if
      next

      
      if w_u_flg% = WRONGWAY then 
        if wrgway_location!(0)-1 = qbert_location!(0) then
          if wrgway_location!(1)+1 = qbert_location!(1) then      
            if wrgway_location!(0)-1 = 0 then
              exit sub
            end if
            set_col_parms(WRONGWAY,0,0,100)
            exit sub
          end if
        end if
      else if w_u_flg% = UGG then
        if ugg_location!(0)-1 = qbert_location!(0) then
          if ugg_location!(1)+1 = qbert_location!(1) then      
            if ugg_location!(0)+1 = 14 then
              exit sub
            end if
            set_col_parms(UGG,0,0,100)
            exit sub
          end if
        end if
      end if


     if gregg_location!(0) = qbert_location!(0) then
       if gregg_location!(1) = qbert_location!(1) then      
          set_col_parms(GREENEGG,0,950,0)
          grtimer% = 0
          
          play modsample FREEZE,1,64,22050   'tune-3.wav  all egg sounds on channel 1, shared with tunes
       end if
     end if

end sub   ' collision


sub set_col_parms(badguy%,cl%,rd%,wr%)
  local it%
  
      settick cl%,coilly,1
      settick rd%,redeg,4
      settick wr%,wrgway,3
      if rd% = 950 then
        pflag% = FALSE        
      else 
        rd% = 0
        pflag% = TRUE
      end if  
      rdg_int% = rd%
      cly_int% = rd%
      ww_int% = rd%
      col_location!(0) = qbert_location!(0)
      col_location!(1) = qbert_location!(1)
      cflag% = badguy%

end sub


sub redeg
  local hd%,vd%,n%,y%,tt1%,tt2%

     

' if qbert landed on a green egg freeze bad guys for some amount of time
  if cflag% = GREENEGG then
    if sprite(x,gr_cur_spr%) <> 10000 then
      sprite hide safe gr_cur_spr%
    end if
    gstate = DEAD
    settick 0,coilly,1
    settick 0,wrgway,3
    inc grtimer%
    if grtimer% > 5 then
      cflag% = FALSE
      inc grcount%,4
      grtimer% = 0
      gregg_location!(0) = 0
      gregg_location!(1) = 0
      settick cly_int%,coilly,1
      settick ww_int%,wrgway,3
      settick rdg_int%,redeg,4
    end if
    exit sub
  end if

  
 
  if level% > 1 then
    if gstate = DEAD then
      inc grtimer%
      if grtimer% > grcount% then
        green_egg_dropin
        gstate = EGG
      end if
   end if
  else if round% >= 3 then
    if gstate = DEAD then
      inc grtimer%
      if grtimer% > grcount% then
        green_egg_dropin
        gstate = EGG
      end if
    end if
  end if
    

  if cflag% = REDEGG then
    collision_recover
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
    exit sub
  end if

'  if grtimer% > grcount% then
'    if gstate = DEAD then
'      green_egg_dropin
'      gstate = EGG
'    end if
'  end if


  for n% = 0 to reggs%-1
   if restate(n%) = EMBRYO then
      rdg_int% = 200
      settick rdg_int%,redeg,4
      restate(n%) = EGG
      exit sub
   end if
  next

  for n% = 0 to reggs%-1
    if restate(n%) = EGG then
      rdg_int% = 950
      settick rdg_int%,redeg,4
    end if
  next
    
  if reggs% >= 2 and rcnt2% = 0 then
    rcnt2% = 1
  end if

  if reggs% > 2 and rcnt3% = 0 then
    rcnt3% = 1
  end if
 
  inc rcnt1%,1
  
  
  if rcnt1% >= 4 then
    if restate(0) = DEAD then  'if red egg is not on playfield
        redeg_dropin(0)

'        exit sub
        rcnt1% = 0
        if reggs% >= 2 then
          rcnt2% = 1
        end if
        if reggs% > 2 then
          rcnt3% = 1
        end if
        
      end if
  end if

  if reggs% > 1 then
    if rcnt2% > 0 then
      inc rcnt2%,1
      if rcnt2% >=7 then 
        if restate(1) = DEAD then
          redeg_dropin(1)
'        exit sub
          rcnt2% = 0
        end if
      end if
    end if
  end if
  
  vd% = 1


  for n% = 0 to reggs%-1
    if restate(n%) = EGG then
      select case redegg_location!(n%,1)

        case 1,2,3,4,5,6,7
          hd% = int(rnd*2)+1
          if hd% = 2 then 
            hd% = -1
          end if
          red_egg_drop(n%,hd%,vd%)

        case 8
          for y% = 0 to 15
            sprite show REDEGG+(n%*2)+1,sprite(x,REDEGG+(n%*2)+1),sprite(y,REDEGG+(n%*2)+1)+y%,1
            pause 5
          next
          restate(n%) = DEAD
          if sprite(x,REDEGG+(n%*2)+1) <> 10000 then
            sprite hide safe REDEGG+(n%*2)+1
          end if
          re_cur_spr%(n%) = REDEGG+(n%*2)
          rdg_int% = 950
          settick rdg_int%,redeg,4

      end select
    end if    
  next


    if gstate = EGG then
      select case gregg_location!(1)

        case 1,2,3,4,5,6,7
          hd% = int(rnd*2)+1
          if hd% = 2 then 
            hd% = -1
          end if
          green_egg_drop(hd%,vd%)

        case 8
          for y% = 0 to 15
            sprite show GREENEGG+1,sprite(x,GREENEGG+1),sprite(y,GREENEGG+1)+y%,1
            pause 5
          next
          gstate = DEAD
          gregg_location!(0) = 0
          gregg_location!(1) = 0
          grtimer% = 0
          if sprite(x,GREENEGG+1) <> 10000 then
            sprite hide safe GREENEGG+1
          end if
          gr_cur_spr% = GREENEGG

      end select
    end if    

end sub   'redeg



sub coilly
  local hd%,vd%,w%

'  exit sub
   
   if cstate = EMBRYO then
      cly_int% = 200
      settick cly_int%,coilly,1
      cstate = EGG
      exit sub
   end if


  if cflag% = COILY then
    collision_recover    
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
    settick ww_int%,wrgway,3
    exit sub
  end if

  if cstate = DEAD then
      cly_int% = 950
      settick cly_int%,coilly,1
    coily_dropin
    cstate = EMBRYO
  end if

  vd% = 1

  if cstate = EGG then
      cly_int% = 950
      settick cly_int%,coilly,1

    if not c_activated%  then
      sprite interrupt collision    
      c_activated% = TRUE
    end if

    select case coily_location!(1)
      case 1,2,3,4,5,6
        hd% = int(rnd*2)+1
        if hd% = 2 then 
          hd% = -1
        end if
        egg_drop(COILYEGG,hd%,vd%)

      case 7
        cstate = LIVE
        for w% = COILYEGG to COILYEGG+1
          if sprite(x,w%) <> 10000 then    
            sprite hide safe w%
          end if
        next
        c_cur_spr% = COILY+UP
        sprite show c_cur_spr%,((coily_location!(0))*16)+qhx,qhy+8+(28*(coily_location!(1)-1)+14),1
        cly_int% = 950
        settick cly_int%,coilly,1
        exit sub
    end select
  end if    


  if cstate = LIVE then
    kill_vector(c_must_die%)
    coily_hop(kvh%,kvv%)
  end if    
  ct2% = timer


end sub   'coily

sub kill_vector(die%)

  if die% = FALSE then
    kvh% = qbert_location!(0) - coily_location!(0)
    if kvh% < 0 then 
      kvh% = -1
    else
      kvh% = 1
    end if

    kvv% = qbert_location!(1) - coily_location!(1)
    if kvv% > 0 then
      kvv% = 1
    else
      kvv% = -1
    end if
  else
    kvh% = coily_death!(0) - coily_location!(0)
    if kvh% < 0 then 
      kvh% = -1
    else
      kvh% = 1
    end if

    kvv% = coily_death!(1) - coily_location!(1)
    if kvv% > 0 then
      kvv% = 1
    else
      kvv% = -1
    end if
  end if  
  
end sub



' flash all the cube tops at level completed
sub cube_flash
 local row%,e%

  play modsample TUNE2,1,64,22050   'tune-2.wav  all tune sounds on channel 1


  for row% = 1 to 10
    if row% = 1 or row% = 3 or row% = 5 or row% = 7 or row% = 9 then
      blit write 64,120,89
    else
      blit write 63,120,89
    end if
    pause 125
  next

  pause 1000

  if level% = 1 then
    if round% >= 2 then
      ww_int% = 3000
      settick ww_int%,wrgway,3
    end if
  else if level% > 1 then
     ww_int% = 3000
     settick ww_int%,wrgway,3
  end if

  if round% < 4 then
    inc round%
    settick 2000,coilly,1
    settick 4000,redeg,4
    ctimer% = timer
    ct% = timer
    cstate = DEAD
    for e% = 0 to reggs%
      restate(e%) = DEAD
    next
  else
    round% = 1
    inc level%
    if reggs% < 3 then
      inc reggs%
    end if
    newlevel = TRUE
    settick 2000,coilly,1
    settick 4000,redeg,4
    settick 3000,wrgway,3
    ctimer% = timer
    ct% = timer
    cstate = DEAD
    wstate = DEAD
    gstate = DEAD
    for e% = 0 to reggs%
      restate(e%) = DEAD
    next
  end if

  'drop_in(TRUE)
    
end sub  'cube flash

sub new_game
  ng_flg% = TRUE
  level% = 1
  round% = 1
  qlives% = 3
  score% = 25
  cube_cnt% = 0
  newlevel = TRUE
  rcnt1% = 0
  rcnt2% = 0
  reggs% = 3
  grcount% = 4

  settick 0,ww_int%,3
  cls

  banner

  timer = 0

  flg% = TRUE

  ' player numer
  blit write 62,68,8
  'level
  blit write 61,340,80
  level_colr% = pixel(343,85)


  'round
  blit write 60,340,90
  round_colr% = pixel(340,95)


  'change to
  blit write 59,10,50


'  reset playfield
  math scale playfield%(),1,field%()
  calc_discs(level%,round%)

draw_cubes(FALSE)

manage_lives(qlives%)

play modsample TUNE,1,64,22050   'tune.wav  all tunes on channel 1

'drop_in(TRUE)

b_spr% = QBERT+DOWN
cur_spr% = QBERT+DOWN

ctimer% = timer

mltimer% = timer

end sub  'new_game

sub screen_refresh
  static t3%
  local t1%,t2%


  if flg% = FALSE then exit sub

  t2% = timer
  if t2% >= 120 then
    discs
    t3% = t3% + t2%
    timer = 0
  end if
  if t3% >= 360 then
    arrows
    t3% = 0
  end if
  
  
end sub



sub discs           'replacing for-next with do-while maybe has fixed an error when using keyboard
  static g%=1

  s% = s% + 1
  p% = p% + 1


  if s% > DISC+3 then s% = DISC
  if p% > 6 then p% = 1


  sprite read PLYRTXT,240,0+p%*8,53,8,3

  do while g% <= 7
    if sdisc!(g%,0) = TRUE then
      blit write s%,sdisc!(g%,1)*16+qhx,sdisc!(g%,2)*28+qhy
    end if
  inc g%
  loop

  g% = 1
' player
   blit write PLYRTXT,10,10
end sub


sub arrows
  static blnk% = 0    'using the static variable and eliminating 1 if-then @ q%=2 appears to have reduced occurence of 
                      '"no matching for" error in sub discs, when using keyboard control.
  q% = q% + 1
  if q% = 3 then q% = 0

  if q% = 0 then

    box 70,50,17,10,,RGB(black),RGB(black)
    box 110,50,20,10,,RGB(black),RGB(black)

    if pawsed then
      text 150,30,"Game Paused",L,3,,RGB(RED)
      inc blnk%
    else if gover% then
      text 150,30,"Game Over - press a key",L,2,,RGB(RED)
      inc blnk%
    else
      text 150,30,"                       ",L,3,,RGB(RED)
    end if

  
  else if q% = 1 then
    blit write 57,120,50
    blit write 58,70,50
  else if q% = 2 then
    blit write 57,110,50
    blit write 58,80,50
'    if pawsed then
'      text 150,30,"           ",L,3,,RGB(RED)
'    end if
'    if gover% then
    if blnk% then
     inc blnk%,-1
     text 150,30,"                       ",L,2,,RGB(RED)
    end if
  end if
    
end sub  



sub elevator(lift,dr)
  local m%,r%,fg%,rloop%


  sdisc!(lift,0) = FALSE

  elev_location!(0) = sdisc!(lift,1)
  elev_location!(1) = sdisc!(lift,2)

'blank out used disc
  box sdisc!(lift,1)*16+qhx,sdisc!(lift,2)*28+qhy,16,16,,RGB(BLACK),RGB(BLACK) 


' choose sprite based on direction
  if dr = 1 then
    sprite read DISC+4,0,181,16,21,3
    sprite read DISC+5,16,181,16,21,3
    sprite read DISC+6,32,181,16,21,3
    sprite read DISC+7,48,181,16,21,3
  else
    sprite read DISC+4,0,160,16,21,3
    sprite read DISC+5,16,160,16,21,3
    sprite read DISC+6,32,160,16,21,3
    sprite read DISC+7,48,160,16,21,3
  end if


  ehv% = dr


  fg% = FALSE


  e% = DISC+4

  settick 300,lift_hop,2

end sub


sub lift_hop

' fg% = FALSE

    for r% = 1 to 16

      if e% = DISC+8 then 
         e% = DISC+4
      end if
      if e% > DISC+4 and e% <= DISC+7 then
        sprite hide safe e% - 1
        pause 7
      end if

      if ehv% = -1 then
        sprite show e%,((elev_location!(0)*16)+qhx)-r%,(elev_location!(1)*28+qhy-5)-r%*1.8,1
        pause 10
      else
        sprite show e%,((elev_location!(0)*16)+qhx)+r%,(elev_location!(1)*28+qhy-5)-r%*1.8,1
        pause 10
      end if
      inc e%

    next

    fg% = TRUE


  if ehv% = -1 then
    inc elev_location!(0),-1
  else
    inc elev_location!(0),1
  end if

  inc elev_location!(1),-1

  if ehv% = 1 then  
    if elev_location!(0) >= 6.5 then
      sprite hide safe e%-1
      settick 0,lift_hop,2
      cly_int% = 950
      settick cly_int%,coilly,1
      drop_in(FALSE)
    end if
  end if

  if ehv% = -1 then  
    if elev_location!(0) <= 7.5 then
      sprite hide safe e%-1
      settick 0,lift_hop,2
      cly_int% = 950
      settick cly_int%,coilly,1
      drop_in(FALSE)
    end if
  end if
    

end sub   'lift hop


sub drop_in(reset%)
  local w%

  if reset% then
    cly_int% = 4000
    rdg_int% = 950
    ww_int% = 0
    if level% = 1 then
      if round% > 2 then
        ww_int% = 3000
      end if
    else
      ww_int% = 3000
    end if
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
    settick ww_int%,wrgway,3    
  else
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4  
    settick ww_int%,wrgway,3    
  end if

  if newlevel = TRUE then 
    c_cnt% = 0
    if c_cnt% = 0 then
      c_cnt% = 1
      newlevel = FALSE  
    coily_location!(0) = 0
    coily_location!(1) = 0
     wrgway_location!(0) = -1
     wrgway_location!(1) = 8
    for w% = 0 to reggs%-1
      redegg_location!(w%,0) = 0
      redegg_location!(w%,1) = 0
    next

    end if
  end if

 qbert_location!(0) = 7
 qbert_location!(1) = 1


  pause 100

  cur_spr% = QBERT+DOWN+1

  for w% = 1 to 20
    sprite show safe QBERT+DOWN+1,7*16+qhx,qhy+(28-13)+w%,1,0
    pause 10
  next

   sprite hide safe cur_spr%

  if level% = 1 then 
    if field%(7,1) = 0 then
      inc field%(7,1)
      inc cube_cnt%
    end if
    math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
    math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
    polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
  end if


  if level% = 2 then
    if field%(7,1) = 0 then
      inc field%(7,1)
      math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
      math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
      polygon c1%,nextx1%(),nexty1%(),color1%(0),color1%(0)
    else if field%(7,1) = 1 then
      inc field%(7,1)
      inc cube_cnt%
      math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
      math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
      polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
    end if
  end if

 inc cur_spr%,-1
 sprite show cur_spr%,7*16+qhx,28+qhy+10,1

  if dabug then
    text 100,10,"cube count = "+str$(cube_cnt%)+" ",L,,,RGB(WHITE)
  end if    

  if qlives% = 3 then
    if ng_flg% then   
      inc qlives%,-1
      manage_lives(qlives%)
      ng_flg% = FALSE
    end if
  else
    manage_lives(qlives%)
  end if

end sub   'drop in


sub redeg_dropin(eggno%)
  local m%
  static side%=1

  if restate(eggno%) = DEAD then
      restate(eggno%) = EMBRYO
    side% = side%*-1
  end if


  for m% = 1 to 28    '40
    sprite show safe REDEGG+eggno%,((7+side%)*16)+qhx,qhy+((28*-1))+m%,1,0
    re_cur_spr%(eggno%) = REDEGG+eggno%
    pause 5
  next
  sprite hide safe REDEGG+eggno%


  sprite show REDEGG+1+eggno%,((7+side%)*16)+qhx,qhy+8+((28*2)-0),1,0



  pause 20
  re_cur_spr%(eggno%) = REDEGG+eggno%+1

  settick rdg_int%,redeg,4
  play modsample EGGDROP,1,64,22050   'jump-3.wav  all egg sounds on channel 1, shared with tunes
 
  redegg_location!(eggno%,0) = 7+side%
  redegg_location!(eggno%,1) = 2

 

  testimer = timer

end sub   'redeg_dropin


sub coily_dropin
  local m%


  if cstate = DEAD then
      cstate = EMBRYO

      side% = rnd*2 '+1
      if side% > 1 then 
        side% = -1
      else
        side% = 1
      end if
  end if

  c_cur_spr% = COILYEGG

  for m% = 1 to 28  '40
    sprite show safe c_cur_spr%,((7+side%)*16)+qhx,qhy+((28*-1))+m%,1,0
    pause 5
  next
  sprite hide safe c_cur_spr%


  c_cur_spr% = COILYEGG+1
  cly_int% = 950
  sprite show c_cur_spr%,((7+side%)*16)+qhx,qhy+8+((28*1)-0)+m%,1,0
'  pause 50
  settick cly_int%,coilly,1
  play modsample EGGDROP,1,64,22050   'jump-3.wav  all egg sounds on channel 1, shared with tunes
 
  coily_location!(0) = 7+side%
  coily_location!(1) = 2


end sub   'red egg dropin


sub red_egg_drop(eggno%,horz%,vert%)   'eggno% 0=1st egg, 1=2nd egg, 2=3rd egg, 3=4th egg
' local b_spr%
 local tmp_loc!(1),n
 static f% = 1

  play modsample EGGDROP,1,64,22050   'jump-3.wav  all egg sounds on channel 1, shared with tunes

 if sprite(x,REDEGG+(2*eggno%)+1) <> 10000 then
    sprite hide safe REDEGG+(2*eggno%)+1
 end if


    re_cur_spr%(eggno%) = (2*eggno%)+REDEGG
    if horz% = 1 then
      tmp_loc!(0) = redegg_location!(eggno%,0) + 1
    else
      tmp_loc!(0) = redegg_location!(eggno%,0) - 1
    end if

    tmp_loc!(1) = redegg_location!(eggno%,1) + 1


  if horz% = 1 then
    sprite show safe REDEGG+(2*eggno%),((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1)-5),1 
    re_cur_spr%(eggno%) = REDEGG+(2*eggno%)
  else
    sprite show safe REDEGG+(2*eggno%),((tmp_loc!(0)+1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1)-5),1 
    re_cur_spr%(eggno%) = REDEGG+(2*eggno%)
  end if
  pause 30
  sprite show safe REDEGG+(2*eggno%),((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-0)-5),1 
  pause 30
  
  sprite hide safe REDEGG+(2*eggno%)

  sprite show safe REDEGG+(2*eggno%)+1,((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1))),1 
  re_cur_spr%(eggno%) = REDEGG+(2*eggno%)+1

  pause 30


    redegg_location!(eggno%,0) = tmp_loc!(0)
    redegg_location!(eggno%,1) = tmp_loc!(1)
 
 

end sub   'redegg drop


sub egg_drop(spr%,horz%,vert%)
 local tmp_loc!(1),n
 static f% = 1

play modsample EGGDROP,1,64,22050   'jump-3.wav  all egg sounds on channel 1

 sprite hide safe spr%+1


  if spr% = COILYEGG then
    c_cur_spr% = spr%
    if horz% = 1 then
      tmp_loc!(0) = coily_location!(0) + 1
    else
      tmp_loc!(0) = coily_location!(0) - 1
    end if
    tmp_loc!(1) = coily_location!(1) + 1
  end if


  if horz% = 1 then
    sprite show safe spr%,((tmp_loc!(0)-1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1)-5),1 
    c_cur_spr% = spr%
  else
    sprite show safe spr%,((tmp_loc!(0)+1)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1)-5),1 
    c_cur_spr% = spr%
  end if
  pause 30
  sprite show safe spr%,((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-0)-5),1 
  pause 30

  sprite hide safe spr%

  sprite show safe spr%+1,((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1))),1 
  c_cur_spr% = spr%+1

  pause 30

  

    coily_location!(0) = tmp_loc!(0)
    coily_location!(1) = tmp_loc!(1)


 
  if cflag% = COILY then
    collision_recover
    settick cly_int%,coilly,1
  else if cflag% = REDEGG then
    collision_recover
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
  else if cflag% = WRONGWAY then
    collision_recover
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
    settick ww_int%,wrgway,3
  end if


end sub   'egg drop



sub coily_hop(horz%,vert%)
 local b_spr%,qr%
 local tmp_loc!(1),r%
 static f% = 1

 play modsample 12,3,64,22050   'jump-4.wav  all coily sounds on channel 3

 if sprite(x,c_cur_spr%) <> 10000 then 
   sprite hide safe c_cur_spr% 'what coily sprite is currently showing
 end if

    if horz% = 1 then
      tmp_loc!(0) = coily_location!(0) + 1
    else
      tmp_loc!(0) = coily_location!(0) - 1
    end if

    if coily_location!(1) = 7 then vert% = -1
      
    if vert% = 1 then
      tmp_loc!(1) = coily_location!(1) + 1
    else
      tmp_loc!(1) = coily_location!(1) - 1
    end if


    select case field%(tmp_loc!(0),tmp_loc!(1))
      case -1
        play modsample 7,3,64,22050   'snake-fall.wav  all coily sounds on channel 3

       score% = score%+500 
       sprite show safe c_cur_spr%,((tmp_loc!(0)-0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)+0))-14),1,qr%
       pause 50

       r% = 0
       do while sprite(y,c_cur_spr%) < 400
         sprite show c_cur_spr%,sprite(x,c_cur_spr%),sprite(y,c_cur_spr%)+r%,1
         inc r%
         pause 5
       loop


       sprite hide safe c_cur_spr%

     
        cstate = dead
        c_must_die% = FALSE
        exit sub
        
      
    end select


 if horz% = 1 then
  if vert% = 1 then
    qr% = 0
    b_spr% = COILY+DOWN
  else
    qr% = 0
    b_spr% = COILY+UP
  end if
 else
  if vert% = 1 then
    qr% = 1
    b_spr% = COILY+DOWN
  else
    qr% = 1
    b_spr% = COILY+UP
  end if
 end if


 c_cur_spr% = b_spr%+1

 sprite show safe c_cur_spr%,((tmp_loc!(0)-0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)+0))-14),1,qr%
 pause 50

 sprite hide safe c_cur_spr%

 c_cur_spr% = b_spr%
 sprite show safe c_cur_spr%,((tmp_loc!(0)-0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)+0)-14),1,qr%



    coily_location!(0) = tmp_loc!(0)
    coily_location!(1) = tmp_loc!(1)
    

    if cflag% <> FALSE then
      if cflag% <> GREENEGG then
        collision_recover
        settick cly_int%,coilly,1
        settick rdg_int%,redeg,4
        settick ww_int%,wrgway,3
      end if
    end if

    if cflag% <> GREENEGG then
      cflag% = FALSE    'reset collision flag
    end if


end sub 'coily hop

sub collision_recover
  local n


    if cflag% = GREENEGG then
      exit sub
    end if
    
    if cflag% = COILY then
          play modsample QBERTDIES,2,64,22050   'swear.wav  all qbert sounds on channel 2
          qstate = DEAD
          cstate = DEAD
          wstate = DEAD
          ustate = DEAD
          
          coily_location!(0)=-99
          coily_location!(1)=-99
          wrgway_location!(0) = -1
          wrgway_location!(1) = 8
          ugg_location!(0) = 14
          ugg_location!(1) = 8
          
          sprite show DOH,qhx+((qbert_location!(0)-1)*16),qhy+(qbert_location!(1)*28)-20,1
          
          PAUSE 1000          
          if sprite(x,DOH) <> 10000 then
            sprite hide DOH
          end if

          for n=0 to reggs%-1
            restate(n) = DEAD
            redegg_location!(n,0)=-99
            redegg_location!(n,1)=-99
          next


          for n = QBERT to UGGU+3
            if sprite(x,n) <> 10000 then
              sprite hide safe n
            end if
          next


          if field%(qbert_location!(0),qbert_location!(1)) = 1 then
            math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
            math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
            polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
          end if

          rcnt1%=0
          rcnt2%=0
          cly_int% = 2000
          rdg_int% = 950
          ww_int% = 3000

     else if cflag% = REDEGG then


          play modsample QBERTDIES,2,64,22050   'swear.wav  all qbert sounds on channel 2

          qstate = DEAD
          cstate = DEAD
          wstate = DEAD
          ustate = DEAD

          sprite show DOH,qhx+(qbert_location!(0)-1)*16),qhy+(qbert_location!(1)*28)-20,1
          PAUSE 1000          

          if sprite(x,DOH) <> 10000 then
            sprite hide DOH
          end if

          coily_location!(0)=-99
          coily_location!(1)=-99
          wrgway_location!(0) = -1
          wrgway_location!(1) = 8
          ugg_location!(0) = 14
          ugg_location!(1) = 8
          
          for n = 0 to reggs%-1
            restate(n) = DEAD  
            redegg_location!(n,0)=-99
            redegg_location!(n,1)=-99
          next


          for n = QBERT to UGGU+3
            if sprite(x,n) <> 10000 then
              sprite hide safe n
            end if
          next


          if field%(qbert_location!(0),qbert_location!(1)) = 1 then
            math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
            math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
            polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
          end if

          rcnt1%=0
          rcnt2%=0
          cly_int% = 2000
          rdg_int% = 950
          ww_int% = 3000
          
      else if cflag% = QBERT then

          for n = QBERT to UGGU+3
            if sprite(x,n) <> 10000 then
              sprite hide safe n
            end if
          next

          qstate = DEAD
          cstate = DEAD
          wstate = DEAD
          ustate = DEAD
          
          for n = 0 to reggs%-1
            restate(n) = DEAD  
            redegg_location!(n,0)=-99
            redegg_location!(n,1)=-99
          next

          coily_location!(0)=-99
          coily_location!(1)=-99
          wrgway_location!(0) = -1
          wrgway_location!(1) = 8
          ugg_location!(0) = 14
          ugg_location!(1) = 8

          rcnt1%=0
          rcnt2%=0
          cly_int% = 2000
          rdg_int% = 950
          ww_int% = 3000
          
     else if cflag% = WRONGWAY then

          play modsample QBERTDIES,2,64,22050   'swear.wav  all qbert sounds on channel 2
          qstate = DEAD
          cstate = DEAD
          wstate = DEAD

          sprite show DOH,qhx+(qbert_location!(0)-1)*16),qhy+(qbert_location!(1)*28)-20,1
          PAUSE 1000          
          sprite hide DOH

          coily_location!(0)=-99
          coily_location!(1)=-99
          wrgway_location!(0) = -1
          wrgway_location!(1) = 8

          for n = 0 to reggs%-1
            restate(n) = DEAD  
            redegg_location!(n,0)=-99
            redegg_location!(n,1)=-99
          next
                    

          for n = QBERT to UGGU+3
            if sprite(x,n) <> 10000 then
              sprite hide safe n
            end if
          next

          fix_tops
                      
          rcnt1%=0
          rcnt2%=0

          cly_int% = 2000
          rdg_int% = 950
          ww_int% = 3000

     else if cflag% = UGG then

          play modsample QBERTDIES,2,64,22050   'swear.wav  all qbert sounds on channel 2
          qstate = DEAD
          cstate = DEAD
          ustate = DEAD

          sprite show DOH,qhx+(qbert_location!(0)-1)*16),qhy+(qbert_location!(1)*28)-20,1
          PAUSE 1000          
          sprite hide DOH

          coily_location!(0)=-99
          coily_location!(1)=-99
          ugg_location!(0) = 14
          ugg_location!(1) = 8

          for n = 0 to reggs%-1
            restate(n) = DEAD  
            redegg_location!(n,0)=-99
            redegg_location!(n,1)=-99
          next
                    

          for n = QBERT to UGGU+3
            if sprite(x,n) <> 10000 then
              sprite hide safe n
            end if
          next

          fix_tops
                      
          rcnt1%=0
          rcnt2%=0

          cly_int% = 2000
          rdg_int% = 950
          ww_int% = 3000

    end if

    inc qlives%,-1
    manage_lives(qlives%)

    cflag% = FALSE
    pflag% = FALSE

end sub   'collision_recover


sub fix_tops
    if level% = 1 then
      if field%(qbert_location!(0),qbert_location!(1)) = 1 then
         math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
         math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
         polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
      end if
    else
      if field%(qbert_location!(0),qbert_location!(1)) = 1 then
         math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
         math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
         polygon c1%,nextx1%(),nexty1%(),color1%(0),color1%(0)
      else
         math add x1%(),(qbert_location!(0)-7)*16,nextx1%()
         math add y1%(),(qbert_location!(1)-1)*28,nexty1%()
         polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
      end if            
    end if
end sub


sub hop(horz%,vert%)
 local tmp_spr%,bonus%,qr%,w%,r%
 local tmp_loc!(1),dst!(1)
 static f% = 1


    tmp_spr% = cur_spr%


    if sprite(x,tmp_spr%) <> 10000 then
      sprite hide safe tmp_spr%
    end if


    fix_tops
    

    play modsample 1,2,64,22050   'jump.wav  all qbert sounds on channel 2

    dst!(0) = abs(qbert_location!(0)-coily_location!(0))
    dst!(1) = abs(qbert_location!(1)-coily_location!(1))

    if horz% = 1 then
      tmp_loc!(0) = qbert_location!(0) + 1
    else
      tmp_loc!(0) = qbert_location!(0) - 1
    end if
    if vert% = 1 then
      tmp_loc!(1) = qbert_location!(1) + 1
    else
      tmp_loc!(1) = qbert_location!(1) - 1
    end if

      qbert_location!(0) = tmp_loc!(0)
      qbert_location!(1) = tmp_loc!(1)


    select case field%(tmp_loc!(0),tmp_loc!(1))


    case 0,1,2
       if horz% = 1 then
         if vert% = 1 then    '(1,1)
          qr% = 0 'not mirrored
          b_spr% = QBERT+DOWN     '1+2 = 3
        else     ' (1,-1)
          qr% = 0 ' not mirrored
          b_spr% = QBERT+UP       '1+0 = 1
        end if
       else
        if vert% = 1 then     '(-1,1)
          qr% = 1 'mirrored
          b_spr% = QBERT+DOWN     '1+2 = 3
        else                  '(-1,-1)
          qr% = 1 'mirrored
          b_spr% = QBERT + UP   '1+0 = 1
        end if
      end if

      sprite show b_spr%+1,((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)-1)-5+14),1,qr% 'QBERT+DNRIGHT+1
      cur_spr% = b_spr%+1

      if level% = 1 then
        math add x1%(),(tmp_loc!(0)-7)*16,nextx1%()
        math add y1%(),(tmp_loc!(1)-1)*28,nexty1%()
        polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)

        if field%(tmp_loc!(0),tmp_loc!(1)) = 0 then    
          inc field%(tmp_loc!(0),tmp_loc!(1))
          score% = score% + 25
          if score% >= 6000 then        
            if qlives% <= 3 then
              if exlife_flag=TRUE then            
                inc qlives%            
                play modsample PRIZE,1,64,22050   'prize.wav  
                manage_lives(qlives%)
                exlife_flag=FALSE
              end if
            end if
          end if
          inc cube_cnt%
        end if
      else if level% >= 2 then      
        if field%(tmp_loc!(0),tmp_loc!(1)) = 0 then        
          math add x1%(),(tmp_loc!(0)-7)*16,nextx1%()
          math add y1%(),(tmp_loc!(1)-1)*28,nexty1%()
          polygon c1%,nextx1%(),nexty1%(),color1%(0),color1%(0)
          score% = score% + 15
          if score% >= 9000*level% then                    
            if qlives% <= 4 then
              if exlife2_flag=TRUE then            
                inc qlives%            
                play modsample PRIZE,1,64,22050   'prize.wav  
                manage_lives(qlives%)
                exlife2_flag=FALSE
              end if
            end if
          end if
          inc field%(tmp_loc!(0),tmp_loc!(1))
        else if field%(tmp_loc!(0),tmp_loc!(1)) = 1 then
          math add x1%(),(tmp_loc!(0)-7)*16,nextx1%()
          math add y1%(),(tmp_loc!(1)-1)*28,nexty1%()
          polygon c1%,nextx1%(),nexty1%(),finishcolor%(0),finishcolor%(0)
    
          inc field%(tmp_loc!(0),tmp_loc!(1))
          score% = score% + 25
          inc cube_cnt%
        end if

      end if



      pause 30
      sprite hide safe b_spr%+1 'QBERT+DNRIGHT+1 


      sprite show b_spr%,((tmp_loc!(0)+0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)+0)),1,qr% 'QBERT+DNRIGHT
      cur_spr% = b_spr%


      if dabug then
        text 100,10,"cube count = "+str$(cube_cnt%)+" ",L,,,RGB(WHITE)
      end if
    
  
      if cube_cnt% = 28 then   'round complete
        round_completed
      end if      

    

      case -1
        play modsample 5,2,64,22050   'fall.wav  all qbert sounds on channel 2

        sprite show safe cur_spr%,((tmp_loc!(0)-0)*16)+qhx,qhy+8+(28*(tmp_loc!(1)+0))-14),1,qr%
        pause 50

        r% = 0
        do while sprite(y,cur_spr%) < 400
          sprite show cur_spr%,sprite(x,cur_spr%),sprite(y,cur_spr%)+r%,1
          inc r%
          pause 5
        loop

        sprite hide safe cur_spr%

        qstate = dead
        pflag% = FALSE
        cflag% = QBERT
        collision_recover 

      
      case 255
        go_elevator(1,1,tmp_loc!(0),tmp_loc!(1),dst!(0),dst!(1),qr%)
              
      case 254
        go_elevator(2,-1,tmp_loc!(0),tmp_loc!(1),dst!(0),dst!(1),qr%)

      case 253
        go_elevator(3,1,tmp_loc!(0),tmp_loc!(1),dst!(0),dst!(1),qr%)

      case 252
        go_elevator(4,-1,tmp_loc!(0),tmp_loc!(1),dst!(0),dst!(1),qr%)

      case 251
        go_elevator(5,1,tmp_loc!(0),tmp_loc!(1),dst!(0),dst!(1),qr%)

      case 250
        go_elevator(6,-1,tmp_loc!(0),tmp_loc!(1),dst!(0),dst!(1),qr%)

      case 249
        go_elevator(7,1,tmp_loc!(0),tmp_loc!(1),dst!(0),dst!(1),qr%)
        

    end select

 
      if cflag% <> FALSE then
        if cflag% <> GREENEGG then
          collision_recover
          settick cly_int%,coilly,1
          settick rdg_int%,redeg,4
          settick ww_int%,wrgway,3
        end if
      end if

      if cflag% <> GREENEGG then
        cflag% = FALSE    'reset collision flag
      end if

      pflag% = FALSE    'reset key/button pressed flag


end sub     'hop


sub go_elevator(num%,side%,lc1!,lc2!,d1!,d2!,mr%)
        qbert_location!(0) = sdisc!(num%,1)
        qbert_location!(1) = sdisc!(num%,2)    
        coily_death!(0) = qbert_location!(0)
        coily_death!(1) = qbert_location!(1)
        sprite show b_spr%+1,((lc1!-1)*16)+qhx,qhy+8+(28*(lc2!-1))-5,1,mr% 'QBERT+DNRIGHT+1
        cur_spr% = b_spr%+1
        pause 10
        sprite hide safe b_spr%+1 'QBERT+DNRIGHT+1
        pause 2
        play modsample 2,2,64,22050   'lift.wav  all qbert sounds on channel 2
        elevator(num%,side%)
        inc disccnt%,-1
        field%(lc1!,lc2!) = -1
        if d1! < 2 then
          if d2! < 2 then           
            c_must_die% = TRUE
            if coily_death(1) <= 3 then
              cly_int% = 500
            end if
          end if
        end if
        settick cly_int%,coilly,1
        pflag% = FALSE
end sub


sub round_completed
        'hide all sprites
        for r% = QBERT to UGGU+3
          if sprite(x,r%) <> 10000 then
            sprite hide safe r%
          end if
        next

        ' stop enemies
        settick 0,redeg,4
        settick 0,coilly,1
        settick 0,wrgway,3
        
        wstate = DEAD
        ustate = DEAD
        gstate = DEAD
                        
        'what it says
        cube_flash
        
        'calculate end of round bonus
        select case round%
          case 1
            bonus% = 1000
          case 2
            bonus% = 1250
          case 3
            bonus% = 1500
          case 4
            bonus% = 1750
        end select

        bonus% = bonus% * level%
        score% = score% + bonus%
        score% = score% + discnt% * 50
        
        cube_cnt% = 0
        draw_cubes(TRUE)
        banner
        help_me
        manage_lives
        
        'reset character positions
        qbert_location(0) = 7
        qbert_location(1) = 1
        coily_location!(0) = 0
        coily_location!(1) = 0
        for w% = 0 to reggs%-1
          redegg_location!(w%,0) = 0
          redegg_location!(w%,1) = 0
        next
        wrgway_location!(0) = -1
        wrgway_location!(1) = 8
        ugg_location!(0) = 14
        ugg_location!(1) = 8
        gregg_location!(0) = 0
        gregg_location!(1) = 0
        grtimer% = 0
        cflag% = FALSE
'        grcount% = 4
        
        drop_in(TRUE)
end sub   'round completed


sub calc_discs(lev%,roun%)
  local d%,i%,idx%,numdiscs%

  if lev% = 1 then numdiscs% = 2
  if lev% = 2 then
    numdiscs% = 3
    if roun% = 3 then numdiscs% = 2
  end if
  if lev% = 3 then
    numdiscs% = 4
    if roun% = 3 then numdiscs% = 3
  end if
  
  discnt% = numdiscs%


  i% = 1 
  if i% <= numdiscs% then
    idx% = cint(rnd*6)+1
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%,0)
    sdisc!(i%,2) =  disc_pairs(idx%,1)
    field%(disc_pairs(idx%,0)+.5,disc_pairs(idx%,1)-1.2) = 255
  end if

  i% = i% + 1 '2
  if i% <= numdiscs% then
    sdisc!(i%,0)  = TRUE
    idx% = cint(rnd*6)+1
    sdisc!(i%,1) =  disc_pairs(idx%+7,0)
    sdisc!(i%,2) =  disc_pairs(idx%+7,1)
    field%(disc_pairs(idx%+7,0)-.5,disc_pairs(idx%+7,1)-1.2) = 254
  end if

  i% = i% + 1 '3
  if i% <= numdiscs% then  
    idx% = cint(rnd*6)+1
    do while disc_pairs(idx%,0) = sdisc(1,1)
      idx% = cint(rnd*6)+1
    loop      
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%,0)
    sdisc!(i%,2) =  disc_pairs(idx%,1)
    field%(disc_pairs(idx%,0)+.5,disc_pairs(idx%,1)-1.2) = 253
  else
      sdisc!(i%,0) = FALSE
  end if
  

  i% = i% + 1 '4
  if i% <= numdiscs% then  
    idx% = cint(rnd*6)+1
    do while disc_pairs(idx%+7,0) = sdisc(2,1)
      idx% = cint(rnd*6)+1
    loop      
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%+7,0)
    sdisc!(i%,2) =  disc_pairs(idx%+7,1)
    field%(disc_pairs(idx%+7,0)-.5,disc_pairs(idx%+7,1)-1.2) = 252
  else
      sdisc!(i%,0) = FALSE
  end if

  i% = i% + 1 '5
  if i% <= numdiscs% then  
    idx% = cint(rnd*6)+1
    do while disc_pairs(idx%,0) = sdisc(1,1) and disc_pairs(idx%,0) = sdisc(3,1)
      idx% = cint(rnd*6)+1
    loop      
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%,0)
    sdisc!(i%,2) =  disc_pairs(idx%,1)
    field%(disc_pairs(idx%,0)+.5,disc_pairs(idx%,1)-1.2) = 251
  else
      sdisc!(i%,0) = FALSE
  end if

  i% = i% + 1 '6
  if i% <= numdiscs% then  
    idx% = cint(rnd*6)+1
    do while disc_pairs(idx%+7,0) = sdisc(2,1) and disc_pairs(idx%+7,0) = sdisc(4,1)
      idx% = cint(rnd*6)+1
    loop      
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%+7,0)
    sdisc!(i%,2) =  disc_pairs(idx%+7,1)
    field%(disc_pairs(idx%+7,0)-.5,disc_pairs(idx%+7,1)-1.2) = 250
  else
      sdisc!(i%,0) = FALSE
  end if

  i% = i% + 1 '7
  if i% <= numdiscs% then  
    idx% = cint(rnd*6)+1
    do while disc_pairs(idx%,0) = sdisc(1,1)
      idx% = cint(rnd*6)+1
    loop      
    sdisc!(i%,0)  = TRUE
    sdisc!(i%,1) =  disc_pairs(idx%,0)
    sdisc!(i%,2) =  disc_pairs(idx%,1)
    field%(disc_pairs(idx%,0)+.5,disc_pairs(idx%,1)-1.2) = 249
  else
      sdisc!(i%,0) = FALSE
  end if

end sub


sub SelectInputDevice(skip_device%)
  local i,d

  
  for i = 0  to 3
    on error skip
    controller nunchuk open i
    if mm.errno > 0 then
      next
    else
      on error skip
      errno = nunchuk(t,i)
      if errno <> &Ha4200000 then

         HaveClassic = TRUE
          controller nunchuk close
          controller classic open i,button_pressed,&b111101110
          channel = i
          exit for
      else if errno = &ha4200000 then
        channel = i
        HaveNunchuk = TRUE
'        settick 7,pollclassic,1
        exit for     
      end if
    end if

  if channel > -1 then exit sub

  keyboard = TRUE
end sub

sub button_pressed
  local pressed

    if qstate = DEAD then exit sub  
'    if cflag% > 0 then exit sub
    if pflag% = TRUE then exit sub

        pressed = classic(b)        
        
        select case pressed and &b111111111
          case 2  ' start button

          case 4  ' home button
          
          case 8  ' select button
          
          case 32 ' cursor down
            pflag% = TRUE        
            hop(1,1)
            exit sub
          
          case 64 ' cursor right
            pflag% = TRUE        
            hop(1,-1)  
            exit sub
          
          case 128  'cursor up
            pflag% = TRUE        
            hop(-1,-1)
            exit sub
          
          case 256  'cursor left
            pflag% = TRUE        
            hop(-1,1)
            exit sub
            
         end select

    
end sub

sub pollkeyboard
     If xp% <> oldxp% or yp% <> oldyp% Then
       oldxp% = xp% : oldyp% = yp%
       GUI CURSOR XP%,YP%
    end if
end sub

sub draw_cubes(clflag%)
  local z%,l%,i%,k%

if clflag% then
  cls

  timer = 0

  flg% = TRUE



  ' player numer
  blit write 62,68,8
  'level
  blit write 61,340,80
  level_colr% = pixel(343,85)


  'round
  blit write 60,340,90
  round_colr% = pixel(340,95)


  'change to
  blit write 59,10,50


'  reset playfield
  math scale playfield%(),1,field%()
  calc_discs(level%,round%)


end if

if level% = 1 then

  select case round%
    case 1
      restore level11
    case 2
      restore level12
    case 3
      restore level13
    case 4
      restore level14
  end select

end if

if level% = 2 then

  select case round%
    case 1
      restore level21
    case 2
      restore level22
    case 3
      restore level23
    case 4
      restore level24
  end select

end if

if level% = 3 then

  select case round%
    case 1
      restore level31
    case 2
      restore level32
    case 3
      restore level33
    case 4
      restore level34
  end select

end if


for z% = 0 to 2
  read startcolor%(z%)
next


polygon c%(),x%(),y%(),startcolor%(),startcolor%()

k% = 6
for l% = 1 to 3
  for i% = 1 to k%
      math add x%(),-(i%*16),nextx%()
      math add y%(),i%*28,nexty%()
      polygon c%(),nextx%(),nexty%(),startcolor%(),startcolor%()
      
      math add x%(),i%*16,nextx%()
      math add y%(),i%*28,nexty%()
      polygon c%(),nextx%(),nexty%(),startcolor%(),startcolor%()

  next

  math add y%(),56,y%()
  polygon c%(),x%(),y%(),startcolor%(),startcolor%()
  k% = k% - 2
next
page copy 0 to 4,b


page write 5
cls
k% = 6

'shift cubes back to the original y position
math add y%(),-(3*56),y%()

for z% = 0 to 2
  read finishcolor%(z%)
next

if level% = 2 then
  for z% = 0 to 2
    read color1%(z%)
  next
end if

polygon c%(),x%(),y%(),finishcolor%(),finishcolor%()

page write 0

image resize 224,92,32,36,90,45,16,18,5


page write 5
for l% = 1 to 3
  for i% = 1 to k%

      math add x%(),-(i%*16),nextx%()
      math add y%(),i%*28,nexty%()
      polygon c%(),nextx%(),nexty%(),finishcolor%(),finishcolor%()
      
      math add x%(),i%*16,nextx%()
      math add y%(),i%*28,nexty%()
      polygon c%(),nextx%(),nexty%(),finishcolor%(),finishcolor%()

  next

  math add y%(),56,y%()
  polygon c%(),x%(),y%(),finishcolor%(),finishcolor%()
  k% = k% - 2
next

  math add y%(),-(3*56),y%()

  k% = 6
page write 0

' used for cube flashing
blit read 64,120,89,9*28,9*28
blit read 63,120,89,9*28,9*28,5




end sub
