sub get_hiscores
  local n
  on error skip
  open "hiscores.dat" for input as #1
  if mm.errno then
    for n = 0 to 9
      hiscores$(n,0) = "00000"
      hiscores$(n,1) = "ZZZ"
    next
    exit sub
  end if
  
  for n = 0 to 9
    input #1,hiscores$(n,0)
    input #1,hiscores$(n,1)
    highscore%(n) = val(hiscores$(n,0))

  next
  close #1

end sub

sub put_scores
  local p
  
  on error skip
  open "hiscores.dat" for output as #2
  for p = 0 to 9
    print #2,hiscores$(p,0)
    print #2,hiscores$(p,1)
  next
  close #2
    
end sub

sub new_hiscore(p%)
  local n
  
  if p% = 9 then
    highscore%(p%) = score%  
    hiscores$(p%,0) = str$(highscore%(p%),5,0,"0")
    hiscores$(p%,1) = player$(cur_plyer%)
  else
    for n = 8 to p% step -1
      hiscores$(n+1,0) = hiscores$(n,0)
      hiscores$(n+1,1) = hiscores$(n,1)
    next   
    highscore%(p%) = score%  
    hiscores$(p%,0) = str$(highscore%(p%),5,0,"0")
    hiscores$(p%,1) = player$(cur_plyer%)
  end if
    

end sub

sub get_player(p%)

page write 2
cls
page display 2
input "Enter player initials, 3 characters max." ; player$(p%)
player$(p%) = left$(player$(p%),3)
cls
page display 0
page write 0

end sub

sub display_hiscores(nscr%,fg%)
  local n,ky$

  ky$ = inkey$
  ky$ = inkey$
  
  page write 2
  cls
  page display 2
  text 35,40,"Top 10 High Scores!",L,5,,RGB(RED)

  for n = 0 to 9
    if n = nscr% then
      text 80,90+n*22,str$(n+1,2,0,"0")+".    "+hiscores$(n,0)+"     "+hiscores$(n,1),L,3,,RGB(RED)
    else  
      text 80,90+n*22,str$(n+1,2,0,"0")+".    "+hiscores$(n,0)+"     "+hiscores$(n,1),L,3,,RGB(BLUE)
    end if
  next

  if fg% then
    text 50,90+(n+1)*22,"Press a key to continue...",L,3,,RGB(BLUE)
  else
    text 50,90+(n+1)*22,"Insert Coin to Play..."+chr$(135),L,1,2,RGB(BLUE)
  end if    

  do while ky$ = ""
    ky$ = inkey$
  loop
 
  
  page write 0
  page display 0
  
end sub
