sub wrgway    'wrongway & ugg interrupt routine
  local hd%,vd%,w%

  
  if cflag% = WRONGWAY then
    collision_recover    
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
    settick ww_int%,wrgway,3
    w_u_flg% = UGG
    exit sub
  else if cflag% = UGG then
    collision_recover    
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
    settick ww_int%,wrgway,3
    w_u_flg% = WRONGWAY
    exit sub
  end if

  if w_u_flg% = WRONGWAY then
    if wstate = DEAD then
      ww_int% = 950
      settick ww_int%,wrgway,3
      w_slide_in
      wstate = LIVE
      exit sub
    end if
  else if w_u_flg% = UGG then
    if ustate = DEAD then
      ww_int% = 950
      settick ww_int%,wrgway,3
      u_slide_in
      ustate = LIVE
      exit sub    
    end if
  end if

  hd% = 1

  if w_u_flg% = WRONGWAY then
    if wstate = LIVE then
      ww_int% = 1100
      settick ww_int%,wrgway,3

      select case wrgway_location!(1)
        case 4  'over only
          vd% = 0
          w_slide(vd%)

        case 5,6,7  'over or up
          vd% = -1*(int(rnd*2)+1)
          if vd% = -2 then 
            vd% = 0
          end if
          w_slide(vd%)
      end select
    end if    
  else if w_u_flg% = UGG then
    if ustate = LIVE then
      ww_int% = 1100
      settick ww_int%,wrgway,3

      select case ugg_location!(1)
        case 4  'over only
          vd% = 0
          u_slide(vd%)

        case 5,6,7  'over or up
          vd% = -1*(int(rnd*2)+1)
          if vd% = -2 then 
            vd% = 0
          end if
          u_slide(vd%)
      end select
    end if      
  end if    

end sub   'wrgway

' inserts wrongway from 0,8 to 1,7
sub w_slide_in()  'insert wrongway onto playfield at (1,7)
  local w%,x%,xofs%,yofs%

  xofs% = -16-2
  yofs% = 28+2
  wrgway_location!(0) = 1
  wrgway_location!(1) = 7

  w_cur_spr% = WRONGWAY

    sprite show safe w_cur_spr%,(0*16)+qhx+xofs%,qhy+(8*28)+yofs%,1,0
    pause 5
    sprite hide safe w_cur_spr%
    inc w_cur_spr%
    sprite show safe w_cur_spr%,(0*16)+qhx+4+xofs%,qhy+(8*28)-7+yofs%,1,0
    pause 5
    sprite hide safe w_cur_spr%
    inc w_cur_spr%
    sprite show safe w_cur_spr%,(0*16)+qhx+8+xofs%,qhy+(8*28)-14+yofs%,1,0
    pause 5
    sprite hide safe w_cur_spr%
    inc w_cur_spr%
    sprite show safe w_cur_spr%,(0*16)+qhx+12+xofs%,qhy+(8*28)-21+yofs%,1,0
    pause 5
    sprite hide safe w_cur_spr%
    w_cur_spr% = WRONGWAY
    sprite show safe w_cur_spr%,(0*16)+qhx+16+xofs%,qhy+(8*28)-28+yofs%,1,0
    pause 5

end sub   'WRONGWAY slide in


sub slide_right(vd%)    'move wrongway either over or over and up
    local n%,stp%,xofs%myofs%

      xofs% = -16-2
      yofs% = 28+2
    
        if vd% = 0 then 'moving horizontal
          if sprite(x,w_cur_spr%) <> 10000 then
            sprite hide safe w_cur_spr%
          end if
          w_cur_spr% = WRONGWAY
          for stp% = 0 to 32 step 8
            for n% = 0 to 3
              sprite show safe w_cur_spr%+n%,(wrgway_location!(0)*16)+qhx+stp%+xofs%,qhy+(wrgway_location!(1)*28)+yofs%,1,0
              if stp% = 32 then
                pause 30
              else
                pause 2
              end if
              sprite hide safe w_cur_spr%+n%
            next
          next
          sprite show safe w_cur_spr%,(wrgway_location!(0)*16)+qhx+stp%+xofs%,qhy+(wrgway_location!(1)*28)+yofs%,1,0
          
          
        else    'moving up
            if sprite(x,w_cur_spr%) <> 10000 then
              sprite hide safe w_cur_spr%
            end if
            w_cur_spr% = WRONGWY
            for n% = 0 to 3
              sprite show safe w_cur_spr%+n%,(wrgway_location!(0)*16)+qhx+0+xofs%,qhy+(wrgway_location!(1)*28)-0+yofs%,1,0
              pause 2
              sprite hide safe w_cur_spr%+n%
            next
'          inc w_cur_spr%
          for n% = 0 to 3
            sprite show safe w_cur_spr%+n%,(wrgway_location!(0)*16)+qhx+4+xofs%,qhy+(wrgway_location!(1)*28)-7+yofs%,1,0
            pause 2
            sprite hide safe w_cur_spr%+n%
          next
'          inc w_cur_spr%
          for n% = 0 to 3
            sprite show safe w_cur_spr%+n%,(wrgway_location!(0)*16)+qhx+8+xofs%,qhy+(wrgway_location!(1)*28)-14+yofs%,1,0
            pause 2
            sprite hide safe w_cur_spr%+n%
          next
'          inc w_cur_spr%
          for n% = 0 to 3
            sprite show safe w_cur_spr%+n%,(wrgway_location!(0)*16)+qhx+12+xofs%,qhy+(wrgway_location!(1)*28)-21+yofs%,1,0
            pause 30
            sprite hide safe w_cur_spr%+n%
          next
          w_cur_spr% = WRONGWY
          sprite show safe w_cur_spr%,(wrgway_location!(0)*16)+qhx+16+xofs%,qhy+(wrgway_location!(1)*28)-28+yofs%,1,0
'          pause 5
        end if


end sub


sub w_slide(vd%)  ' calculate wrongway movement
  local tmp_loc!(1),r%
  
 play modsample 8,1,64,22050   'speech.wav  all wrongway sounds on channel 1

' sprite hide safe w_cur_spr% 'what coily sprite is currently showing

    if vd% = 0 then
      tmp_loc!(0) = wrgway_location!(0) + 2
      tmp_loc!(1) = wrgway_location!(1)     
    else
      tmp_loc!(0) = wrgway_location!(0) + 1
      tmp_loc!(1) = wrgway_location!(1) - 1    
    end if

    
    if tmp_loc!(0) > 14 then
      tmp_loc!(0) = 14
    end if
    select case field%(tmp_loc!(0),tmp_loc!(1))
      case -1,-2   'going off playfield, move and exit stage right

        slide_right(vd%)        
        pause 50

        r% = 0
        do while sprite(x,w_cur_spr%) < 390
          sprite show safe w_cur_spr%,sprite(x,w_cur_spr%)+r%,sprite(y,w_cur_spr%),1
          inc r%
          pause 5
        loop
                
        sprite hide safe w_cur_spr%

        ww_int% = 3000
        settick ww_int%,wrgway,3     
        wstate = dead    
        w_u_flg% = UGG
        wrgway_location!(0) = 8
        wrgway_location!(1) = 0
    
        exit sub

      case else
        
        slide_right(vd%)
      
    end select

    wrgway_location!(0) = tmp_loc!(0)
    wrgway_location!(1) = tmp_loc!(1)
    
 cf% = FALSE

  if cflag% = WRONGWAY then
    collision_recover
    settick ww_int%,wrgway,3
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
  else if cflag% = REDEGG then
    collision_recover
    settick ww_int%,wrgway,3
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
  else if cflag% = COILY then
    collision_recover
    settick ww_int%,wrgway,3
    settick cly_int%,coilly,1
    settick rdg_int%,redeg,4
  end if

  cflag% = FALSE

  
end sub




